<id>
Password Security
</id>

<version>
1.3 SP1.3
</version>

<mod info>
Eliminate all plain ASCII storage of members' passwords.
New Admin screen contains option to "Repair Passwords" which will automatically 
upgrade all existing plain passwords to encrypted versions, skipping the passwords 
which are already encrypted.  Adds secret question / answer to registration, profile, 
and forget password sections. Forget password function has one more layer, after 
they enter their username they are presented with their secret question.  
If they answer correctly, a new password will be emailed to them. All Passwords 
and Secret Question answers are stored encrypted, no more plain ascii passwords anywhere!

Original Mod by Matthew C. Veno

Version 1.1 Update - Bug Fix
Fixed bug where when Admin modifies users' profile the users' password and secret answer were changed and unusable.

Version 1.1SP1.1 (by Chrishartmann)
Mod modified for use with YaBB 1 Gold - SP1.1

Version 1.3SP1.3 (by DummyProof)
Mod modified for use with YaBB 1 Gold - SP1.3
Corrected Reminder Answer screen that would not show if "No Guest Access" was used.

For detailed installation information please open yabbpass.html
</mod info>

<author>
Matthew C. Veno \ Chrishartmann \ DummyProof
</author>

<homepage>
http://dummyyabb.sourceforge.net/cgi-bin/DYaBB2/YaBB.pl
</homepage>

<edit file>
Sources/Load.pl
</edit file>

<search for>
			$spass = crypt($settings[0],$pwseed);
			if($spass ne $password && $action ne 'logout') { $username = ''; }
</search for>

<replace>
			if($settings[0] ne $password && $action ne 'logout') { $username = ''; }
</replace>

<edit file>
english.lng
</edit file>

<search for>
$txt{'749'} = "The 'number of posts' box can only contain digits.";
</search for>

<add after>
$pwtxt{'750'} = "Repair all Passwords";
$pwtxt{'751'} = "Processing User: ";
$pwtxt{'752'} = "Password Updated";
$pwtxt{'753'} = "Password OK -- Skipped";
$pwtxt{'754'} = "All the Passwords have been Repaired.";
$pwtxt{'755'} = "Secret Question";
$pwtxt{'756'} = "Choose a question only you know the answer to and that has nothing to do with your password. If you forget your password, we'll verify your identity by asking you this question.";
$pwtxt{'757'} = "Answer to Secret Question";
$pwtxt{'758'} = "The Secret Question was not filled out. It is required.";
$pwtxt{'759'} = "The Answer to Secret Question was not filled out. It is required.";
$pwtxt{'760'} = "Sorry, that is not the correct answer!";

</add after>

<edit file>
Sources/AdminEdit.pl
</edit file>

<search for>
	$password = crypt($settings[0],$pwseed);
</search for>

<replace>
	$password = $settings[0];
</replace>

<edit file>
Sources/Admin.pl
</edit file>

<search for>
        - <a href="$cgi;action=membershiprecount">$txt{'504'}</a><br>
</search for>

<add before>
        - <a href="$cgi&action=repairpasswords">$pwtxt{'750'}</a><br>
</add before>

<search for>
sub AdminBoardRecount {
</search for>

<add before>
sub RepairPasswords {
        &is_admin;
	  @users = '';
        $yytitle = "$pwtxt{'750'}";
        opendir(DIR, "$memberdir") || die "$txt{'230'} ($memberdir) :: $!";
        @contents = readdir(DIR);
        closedir(DIR);
	  $yymain .= qq~<hr>$pwtxt{'750'}<br>~;
        foreach $line (sort @contents){
                $line =~ m~(.+)\.(.+)~;
                if ($2 eq 'dat' && $1 ne 'admin') {
			my $user = $1;
			$yymain .= qq~$pwtxt{'751'} $user -- ~;
		        fopen(FILE, "$memberdir/$user.dat");
		        @memsettings=<FILE>;
		        fclose(FILE);
		        foreach (@memsettings) {
	                	$_ =~ s~[\n\r]~~g;
        		}
			if ((substr $memsettings[0],0,2) ne $pwseed) {
				fopen( FILE, ">$memberdir/$user.dat", 1);
				$cryptpass = crypt("$memsettings[0]",$pwseed);
				print FILE "$cryptpass\n";
				for ($i=1;$i<=$#memsettings;$i++) {
					print FILE "$memsettings[$i]\n";
				}
				fclose(FILE);
				$yymain .= qq~$pwtxt{'752'}<br>~;
			}
			else {  $yymain .= qq~$pwtxt{'753'}<br>~; }
                }
        }
        $yymain .= qq~<p><b>$pwtxt{'754'}</b>~;
        &template;
        exit;
}

</add before>

<edit file>
Sources/Profile.pl
</edit file>

<search for>
	<td><input type="text" maxlength="40" name="email" size="30" value="$memsettings[2]"></td>
      </tr>
</search for>

<add after>
      <tr>
        <td width="320"><font size=2><b>$pwtxt{'755'}: </b></font><BR>
        <font size="1">$pwtxt{'756'}</font></td>
        <td><input type="text" name="secretquestion" size="30" value="$memsettings[20]"></td>
      </tr><tr>
        <td width="320"><font size=2><b>$pwtxt{'757'}: </b></font><BR></td>
        <td><input type="password" name="secretanswer" size="30" value="$memsettings[21]"></td>
      </tr>
</add after>

<search for>
	if( $member{'bday1'} ne "" || $member{'bday2'} ne "" || $member{'bday3'} ne "" ) {
</search for>

<add before>
	&fatal_error("$pwtxt{'758'}") if($member{'secretquestion'} eq '');
	&fatal_error("$pwtxt{'759'}") if($member{'secretanswer'} eq '');
</add before>

<search for>
		fopen( FILE, ">$memberdir/$member{'username'}.dat", 1);
		print FILE "$member{'passwrd1'}\n";
</search for>

<replace>
                fopen(SETTINGS, "$memberdir/$member{'username'}.dat");
                @userProfileSettings = <SETTINGS>;
                fclose(SETTINGS);
                chomp $userProfileSettings[0];
                chomp $userProfileSettings[21];

                if ($member{'passwrd1'} eq $userProfileSettings[0]) {

			$cryptpass = $member{'passwrd1'};
		}
		else {
			$cryptpass = crypt("$member{'passwrd1'}",$pwseed);
		}
                if ($member{'secretanswer'} eq $userProfileSettings[21]) {
                        $cryptanswer = $member{'secretanswer'};
		}
                else {
                        $cryptanswer = crypt("$member{'secretanswer'}",$pwseed);
		}

		fopen( FILE, ">$memberdir/$member{'username'}.dat", 1);
		print FILE "$cryptpass\n";
</replace>

<search for>
		print FILE "$FORM{'hideemail'}\n";
</search for>

<add after>
		print FILE "$member{'secretquestion'}\n";
		print FILE "$cryptanswer\n";
</add after>

<search for>
			$password = crypt("$member{'passwrd1'}",$pwseed);
</search for>

<replace>
			$password = $cryptpass;
</replace>

<edit file>
Sources/Register.pl
</edit file>

<search for>
    </table>
    </font></td>
  </tr>
</table>
~;
</search for>

<add before>
      <tr>
        <td width="40%"><font size=2>* <b>$pwtxt{'755'}:</b></font>
	<BR><font size="1">$pwtxt{'756'}</font></td>
        <td><font size=2><input type=text name=secretquestion size=30></font></td>
      </tr><tr>
        <td width="40%"><font size=2>* <b>$pwtxt{'757'}:</b></font></td>
        <td><font size=2><input type=password name=secretanswer size=30></font></td>
      </tr>
</add before>

<search for>
	&fatal_error("($member{'username'}) $txt{'100'}") if(-e ("$memberdir/$member{'username'}.dat"));
</search for>

<add after>
	&fatal_error("($member{'username'}) $pwtxt{'758'}") if($member{'secretquestion'} eq '');
	&fatal_error("($member{'username'}) $pwtxt{'759'}") if($member{'secretanswer'} eq '');
</add after>

<search for>
	print FILE "$member{'passwrd1'}\n";
</search for>

<replace>
	$cryptpass = crypt("$member{'passwrd1'}",$pwseed);
	print FILE "$cryptpass\n";
</replace>

<search for>
	print FILE "$FORM{'hideemail'}\n";
</search for>

<add after>
	print FILE "$member{'secretquestion'}\n";
	$cryptanswer = crypt("$member{'secretanswer'}",$pwseed);
	print FILE "$cryptanswer\n";
</add after>

<edit file>
YaBB.pl
</edit file>

<search for>
	if(!(($action eq 'login') || ($action eq 'login2') || ($action eq 'register') || ($action eq 'register2') || ($action eq 'reminder') || ($action eq 'reminder2'))) { &KickGuest; }
</search for>

<replace>
	if(!(($action eq 'login') || ($action eq 'login2') || ($action eq 'register') || ($action eq 'register2') || ($action eq 'reminder') || ($action eq 'reminder2') || ($action eq 'reminder_answer'))) { &KickGuest; }
</replace>

<edit file>
Sources/SubList.pl
</edit file>

<search for>
'usersrecentposts',"Profile.pl&usersrecentposts");
</search for>

<add before>
'repairpasswords',"Admin.pl&RepairPasswords",
'reminder_answer',"LogInOut.pl&Reminder_answer",
</add before>

<edit file>
Sources/LogInOut.pl
</edit file>

<search for>
		if($settings[0] ne "$FORM{'passwrd'}") { $username = "Guest"; &fatal_error("$txt{'39'}"); }
</search for>

<replace>
		$password = crypt("$FORM{'passwrd'}",$pwseed);
		if($settings[0] ne $password) { $username = "Guest"; &fatal_error("$txt{'39'}"); }
</replace>

<search for>
$password = $member[0];
</search for>

<replace>
foreach (@member) {
	$_ =~ s~[\n\r]~~g;
}

$cryptanswer = crypt("$FORM{'secretanswer'}",$pwseed);
&fatal_error("$pwtxt{'760'}") if($cryptanswer ne $member[21]);
$yytitle="$mbname $txt{'669'}";

srand();
$newpasswrd = int( rand(100) );
$newpasswrd =~ tr/0123456789/ymifxupbck/;
$_ = int( rand(77) );
$_ =~ tr/0123456789/q8dv7w4jm3/;
$newpasswrd .= $_;
$_ = int( rand(89) );
$_ =~ tr/0123456789/y6uivpkcxw/;
$newpasswrd .= $_;
$_ = int( rand(188) );
$_ =~ tr/0123456789/poiuytrewq/;
$newpasswrd .= $_;
$_ = int( rand(65) );
$_ =~ tr/0123456789/lkjhgfdaut/;
$newpasswrd .= $_;
$cryptpass = crypt($newpasswrd,$pwseed);

fopen( FILE, ">$memberdir/$user.dat", 1);
print FILE "$cryptpass\n";
for ($i=1;$i<=$#member;$i++) {
	print FILE "$member[$i]\n";
}
fclose(FILE);

$password = $newpasswrd;
</replace>

<search for>
<br><center><a href="javascript:history.back(-2)">$txt{'193'}</a></center><br>
</search for>

<replace>
<br><center><a href="$cgi;action=login">$txt{'34'}</a></center><br>
</replace>

<search for>
    <form action="$cgi;action=reminder2" method="POST">
</search for>

<replace>
    <form action="$cgi;action=reminder_answer" method="POST">
</replace>

<search for>
sub Reminder2 {
</search for>

<add before>
sub Reminder_answer {
$user = $FORM{'user'};

	fopen(FILE, "$memberdir/$user.dat") || &fatal_error("<b>$txt{'40'}</b>");
	@member=<FILE>;
	fclose(FILE);

        $yymain .= qq~
<BR><BR><table border=0 cellspacing=1 bgcolor="$color{'bgcolor'}" align="center">
  <tr>
    <td class="titlebg" bgcolor="$color{'titlebg'}">
    <font size=2 class="text1" color="$color{'titletext'}"><b>$mbname $txt{'36'} $txt{'194'}</b></b></font></td>
  </tr><tr>
    <td class="windowbg" bgcolor="$color{'windowbg'}">
    <form action="$cgi;action=reminder2" method="POST">
    <table border=0 align="center">
      <tr>
        <td><font size="2">$user, $pwtxt{'755'}:</td>
	<td><font size="2">$member[20]</td>
      </tr>
      <tr>
        <td><font size="2">$pwtxt{'757'}:</td>
        <td><input type="password" name="secretanswer" size="30"></td>
      </tr>
      <tr>
        <td colspan="2" align="center"><input type="hidden" name="user" value="$user">
	<input type="submit" value="$txt{'339'}"></td>
      </tr>
    </table>
    </form>
    </td>
  </tr>
</table>
~;
$yytitle = "$txt{'669'}";
&template;
exit;
}

</add before>